Search code examples
ubuntucrondaemoninit.dskeleton-code

How do I prevent start-stop-daemon from creating multiple instances in a cronjob?


Alright, I copied /etc/init.d/skeleton to /etc/init.d/ark-server for starting and stopping an ARK: Survival Evolved server and I have the following file:

#! /bin/sh
### BEGIN INIT INFO
# Provides:          skeleton
# Required-Start:    $remote_fs $syslog
# Required-Stop:     $remote_fs $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Example initscript
# Description:       This file should be used to construct scripts to be
#                    placed in /etc/init.d.
### END INIT INFO

# Author: Foo Bar <[email protected]>
#
# Please remove the "Author" lines above and replace them
# with your own name if you copy and modify this script.

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=<path_to_ark>/ShooterGame/Binaries/Linux:/sbin:/usr/sbin:/bin:/usr/bin
DESC="ARK Dedicated Server"
NAME=ShooterGameServer
DAEMON=<path_to_ark>/ShooterGame/Binaries/Linux/$NAME
DAEMON_ARGS="\"TheIsland?listen?MultiHome=<ip>?QueryPort=<port>?ServerAdminPassword=<password>\" -nosteamclient -game -server -log"
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
        # Return
        #   0 if daemon has been started
        #   1 if daemon was already running
        #   2 if daemon could not be started
        start-stop-daemon --start --quiet --background --pidfile $PIDFILE --make-pidfile --chuid 1000:1000 --exec $DAEMON --test > /dev/null 2>&1 \
                || return 1
        start-stop-daemon --start --quiet --background --pidfile $PIDFILE --make-pidfile --chuid 1000:1000 --exec $DAEMON -- \
                $DAEMON_ARGS \
                || return 2
        # Add code here, if necessary, that waits for the process to be ready
        # to handle requests from services started subsequently which depend
        # on this one.  As a last resort, sleep for some time.
        #return 0
}

#
# Function that stops the daemon/service
#
do_stop()
{
        # Return
        #   0 if daemon has been stopped
        #   1 if daemon was already stopped
        #   2 if daemon could not be stopped
        #   other if a failure occurred
        start-stop-daemon --stop --quiet --retry=TERM/30/INT/15/KILL/5 --pidfile $PIDFILE --chuid 1000:1000 --exec $DAEMON
        RETVAL="$?"
        [ "$RETVAL" = 2 ] && return 2
        # Wait for children to finish too if this is a daemon that forks
        # and if the daemon is only ever run from this initscript.
        # If the above conditions are not satisfied then add some other code
        # that waits for the process to drop all resources that could be
        # needed by services started subsequently.  A last resort is to
        # sleep for some time.
        ##start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
        ##[ "$?" = 2 ] && return 2
        # Many daemons don't delete their pidfiles when they exit.
        rm -f $PIDFILE
        return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
        #
        # If the daemon can reload its configuration without
        # restarting (for example, when it is sent a SIGHUP),
        # then implement that here.
        #
        start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME &
        return 0
}

case "$1" in
  start)
        [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
        do_start
        case "$?" in
                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
  stop)
        [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
        do_stop
        case "$?" in
                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
  status)
       status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
       ;;
  #reload|force-reload)
        #
        # If do_reload() is not implemented then leave this commented out
        # and leave 'force-reload' as an alias for 'restart'.
        #
        #log_daemon_msg "Reloading $DESC" "$NAME"
        #do_reload
        #log_end_msg $?
        #;;
  restart|force-reload)
        #
        # If the "reload" option is implemented then remove the
        # 'force-reload' alias
        #
        log_daemon_msg "Restarting $DESC" "$NAME"
        do_stop
        case "$?" in
          0|1)
                do_start
                case "$?" in
                        0) log_end_msg 0 ;;
                        1) log_end_msg 1 ;; # Old process is still running
                        *) log_end_msg 1 ;; # Failed to start
                esac
                ;;
          *)
                # Failed to stop
                log_end_msg 1
                ;;
        esac
        ;;
  *)
        #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
        echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
        exit 3
        ;;
esac

And here are my cron entries:

0 12,3 * * 1-5 /etc/init.d/ark-server restart
0 6 * * 0,6 /etc/init.d/ark-server restart

If I restart the server manually, it always ends the current process and creates a new one. However, when the cronjobs run, it does this:

top - 18:47:08 up 60 days, 20:39,  2 users,  load average: 3.43, 3.36, 3.39
Tasks: 215 total,   4 running, 211 sleeping,   0 stopped,   0 zombie
Cpu(s): 15.7%us, 31.6%sy,  0.0%ni, 49.3%id,  3.4%wa,  0.0%hi,  0.0%si,  0.0%st
Mem:  24397548k total, 23295208k used,  1102340k free,    36332k buffers
Swap:  7996348k total,   192228k used,  7804120k free,  7754660k cached

  PID USER      PR  NI  VIRT  RES  SHR S %CPU %MEM    TIME+  COMMAND
31329 ark     20   0 2927m 1.9g  27m R  143  8.3   0:14.45 ShooterGameServ
28672 ark     20   0 4349m 3.9g  31m R  100 16.8 948:52.64 ShooterGameServ
19470 ark     20   0 4343m 3.9g  29m R   92 16.7   2388:36 ShooterGameServ
14218 ark     20   0 5211m 4.0g  18m S   24 17.2   2975:16 ShooterGameServ

How do I stop my script from creating multiple instances in cronjobs?

This is all I have in the log files:

$ cat Logs/ShooterGame_2-backup-2015.11.21-01.10.20.log
[2015.11.20-17.09.30:075][  0]Log file open, 11/20/15 11:09:30
[2015.11.20-17.09.30:075][  0]Primal Game Data Took 15.39 seconds

Both ShooterGame.log and ShooterGame_2.log are empty.

So what I've noticed is the restart only fails and creates a new instance of the server if the server's been running for more than 12 hours. This is what happened when I restarted the server today:

$ cat /var/run/ShooterGameServer.pid
16330
$ sudo /etc/init.d/ark-server restart
 * Restarting ARK Dedicated Server ShooterGameServer                                                             [ OK ]
$ cat /var/run/ShooterGameServer.pid
21094
$ kill -9 16330
$ kill -9 21094

It booted up a second process with PID 21094 without ending the process with PID 16330. However, if I kill both of these processes and restart the server with the same script, it always closes the first process prior.


Solution

  • I just put a kill -9 after the RETVAL to make sure it ends. Not the most elegant solution and I'd like to know why start-stop-daemon doesn't work, but here's the code:

    #
    # Function that stops the daemon/service
    #
    do_stop()
    {
            # Return
            #   0 if daemon has been stopped
            #   1 if daemon was already stopped
            #   2 if daemon could not be stopped
            #   other if a failure occurred
            # --retry=TERM/30/INT/15/KILL/5
            start-stop-daemon --stop --quiet --retry TERM/forever/KILL/5 --pidfile $PIDFILE --chuid 1000:1000 --exec $DAEMON
            RETVAL="$?"
            kill -9 `cat $PIDFILE`
            [ "$RETVAL" = 2 ] && return 2
            # Wait for children to finish too if this is a daemon that forks
            # and if the daemon is only ever run from this initscript.
            # If the above conditions are not satisfied then add some other code
            # that waits for the process to drop all resources that could be
            # needed by services started subsequently.  A last resort is to
            # sleep for some time.
            ##start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
            ##[ "$?" = 2 ] && return 2
            # Many daemons don't delete their pidfiles when they exit.
            rm -f $PIDFILE
            return "$RETVAL"
    }
    

    I'm not going to accept this answer yet in case someone actually knows how to get start-stop-daemon working properly.